CREATE TABLE [dbo].[glOptionen] (
	[Schlssel] [varchar] (50) NOT NULL ,
	[Wert] [varchar] (200) NOT NULL ,
	[Parameter] [varchar] (50) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[glUserOptionen] (
	[UserName] [varchar] (50) NOT NULL ,
	[Schlssel] [varchar] (50) NOT NULL ,
	[Wert] [varchar] (50) NOT NULL ,
	[lfdnr] [int] NULL 
) ON [PRIMARY]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

Create PROCEDURE dbo.au_OptGet @Opt varchar(255), @Typ varchar(1) = 'U', @Sort int =1
AS

	IF upper(@Typ)='U'
		IF upper(@Opt)='WHOAMI'
			SELECT user as Wert, null as Parameter
		ELSE
			SELECT g.Wert, g.Parameter FROM glUserOptionen g WHERE g.Username=user AND g.Schlssel=@Opt
	ELSE
		SELECT Wert, Parameter FROM glOptionen g WHERE g.Schlssel=@Opt ORDER BY ascii(Wert)*@Sort
GO

CREATE PROCEDURE dbo.au_OptLet @Opt varchar(255), @Val varchar(255), @Param varchar(255)='', @Typ char(1) = 'U'
AS

	IF upper(@Typ)='U'
		BEGIN
			IF exists (SELECT Wert FROM glUserOptionen g WHERE g.Username=@user AND g.Schlssel=@Opt)
				UPDATE glUserOptionen SET Wert=@Val WHERE Schlssel=@Opt AND Username=user
			ELSE
				INSERT INTO glUserOptionen (Username, Schlssel, Wert) VALUES (User, @Opt, @Val)
		END
	ELSE
		BEGIN
			IF @val<>''
				IF exists (SELECT Wert FROM glOptionen g WHERE g.Schlssel=@Opt)
					UPDATE glOptionen SET Wert=@Val, Parameter=@Param WHERE Schlssel=@Opt
				ELSE
					INSERT INTO glOptionen (Schlssel, Wert, Parameter) VALUES (@Opt, @Val, @Param)
			ELSE
				DELETE FROM glOptionen WHERE Schlssel=@Opt
		END



GO